Index: sasmodels/models/sc_paracrystal.c
===================================================================
--- sasmodels/models/sc_paracrystal.c	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/sc_paracrystal.c	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -49,17 +49,15 @@
 	double da = d_factor*dnn;
 	double temp1 = qq*qq*da*da;
-	double temp2 = pow( 1.0-exp(-1.0*temp1) ,3);
+	double temp2 = cube(-expm1(-temp1));
 	double temp3 = qq*dnn;
 	double temp4 = 2.0*exp(-0.5*temp1);
 	double temp5 = exp(-1.0*temp1);
 
-	double integrand = temp2*sc_eval(yy,xx,temp3,temp4,temp5);
-	integrand *= 2.0/M_PI;
+	double integrand = temp2*sc_eval(yy,xx,temp3,temp4,temp5)/M_PI_2;
 
 	return(integrand);
 }
 
-static
-double sc_crystal_kernel(double q,
+double Iq(double q,
           double dnn,
           double d_factor,
@@ -69,5 +67,5 @@
 {
 	const double va = 0.0;
-	const double vb = M_PI/2.0; //orientation average, outer integral
+	const double vb = M_PI_2; //orientation average, outer integral
 
     double summ=0.0;
@@ -103,6 +101,5 @@
 }
 
-static
-double sc_crystal_kernel_2d(double q, double q_x, double q_y,
+double Iqxy(double qx, double qy,
           double dnn,
           double d_factor,
@@ -114,115 +111,18 @@
           double psi)
 {
-    //convert angle degree to radian
-    theta = theta * M_PI_180;
-    phi = phi * M_PI_180;
-    psi = psi * M_PI_180;
+    double q, cos_a1, cos_a2, cos_a3;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_a3, cos_a2, cos_a1);
 
-    const double qda_2 = pow(q*d_factor*dnn,2.0);
+    const double qd = q*dnn;
+    const double arg = 0.5*square(qd*d_factor);
+    const double tanh_qd = tanh(arg);
+    const double cosh_qd = cosh(arg);
+    const double Zq = tanh_qd/(1. - cos(qd*cos_a1)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*cos_a2)/cosh_qd)
+                    * tanh_qd/(1. - cos(qd*cos_a3)/cosh_qd);
 
-    double snt, cnt;
-    SINCOS(theta, snt, cnt);
-
-    double snp, cnp;
-    SINCOS(phi, snp, cnp);
-
-    double sns, cns;
-    SINCOS(psi, sns, cns);
-
-    /// Angles here are respect to detector coordinate instead of against
-    //  q coordinate(PRB 36, 3, 1754)
-    // a3 axis orientation
-
-    const double a3_x = cnt * cnp;
-    const double a3_y = snt;
-
-    // Compute the angle btw vector q and the a3 axis
-    double cos_val_a3 = a3_x*q_x + a3_y*q_y;
-
-    // a1 axis orientation
-    const double a1_x = -cnp*sns * snt+snp*cns;
-    const double a1_y = sns*cnt;
-
-    double cos_val_a1 = a1_x*q_x + a1_y*q_y;
-
-    // a2 axis orientation
-    const double a2_x = -snt*cns*cnp-sns*snp;
-    const double a2_y = cnt*cns;
-
-    // a2 axis
-    const double cos_val_a2 =  a2_x*q_x + a2_y*q_y;
-
-    // The following test should always pass
-    if (fabs(cos_val_a3)>1.0) {
-        //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-        cos_val_a3 = 1.0;
-    }
-    if (fabs(cos_val_a1)>1.0) {
-        //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-        cos_val_a1 = 1.0;
-    }
-    if (fabs(cos_val_a2)>1.0) {
-        //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-        cos_val_a3 = 1.0;
-    }
-
-    const double a3_dot_q = dnn*q*cos_val_a3;
-    const double a1_dot_q = dnn*q*cos_val_a1;
-    const double a2_dot_q = dnn*q*cos_val_a2;
-
-    // Call Zq=Z1*Z2*Z3
-    double Zq = (1.0-exp(-qda_2))/(1.0-2.0*exp(-0.5*qda_2)*cos(a1_dot_q)+exp(-qda_2));
-    Zq *= (1.0-exp(-qda_2))/(1.0-2.0*exp(-0.5*qda_2)*cos(a2_dot_q)+exp(-qda_2));
-    Zq *= (1.0-exp(-qda_2))/(1.0-2.0*exp(-0.5*qda_2)*cos(a3_dot_q)+exp(-qda_2));
-
-    // Use SphereForm directly from libigor
-    double answer = sphere_form(q, radius, sphere_sld, solvent_sld)*Zq;
-
-    //consider scales
-    const double latticeScale = sphere_volume(radius/dnn);
-    answer *= latticeScale;
-
-    return answer;
+    const double Fq = sphere_form(q, radius, sphere_sld, solvent_sld)*Zq;
+    //the occupied volume of the lattice
+    const double lattice_scale = sphere_volume(radius/dnn);
+    return lattice_scale * Fq;
 }
-
-double Iq(double q,
-          double dnn,
-          double d_factor,
-          double radius,
-          double sphere_sld,
-          double solvent_sld)
-{
-    return sc_crystal_kernel(q,
-              dnn,
-              d_factor,
-              radius,
-              sphere_sld,
-              solvent_sld);
-}
-
-// Iqxy is never called since no orientation or magnetic parameters.
-double Iqxy(double qx, double qy,
-            double dnn,
-            double d_factor,
-            double radius,
-            double sphere_sld,
-            double solvent_sld,
-            double theta,
-            double phi,
-            double psi)
-{
-    double q = sqrt(qx*qx + qy*qy);
-
-
-    return sc_crystal_kernel_2d(q, qx/q, qy/q,
-                  dnn,
-                  d_factor,
-                  radius,
-                  sphere_sld,
-                  solvent_sld,
-                  theta,
-                  phi,
-                  psi);
-
-}
-
Index: sasmodels/models/sc_paracrystal.py
===================================================================
--- sasmodels/models/sc_paracrystal.py	(revision 0bef47b278e819df7ea6b572375dd7bc9607227e)
+++ sasmodels/models/sc_paracrystal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -133,5 +133,5 @@
 # pylint: enable=bad-whitespace, line-too-long
 
-source = ["lib/sph_j1c.c", "lib/sphere_form.c", "lib/gauss150.c", "sc_paracrystal.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sphere_form.c", "lib/gauss150.c", "sc_paracrystal.c"]
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/sphere.py
===================================================================
--- sasmodels/models/sphere.py	(revision 7e6bea817616b3ff05f1c96c2a11a94853dc6276)
+++ sasmodels/models/sphere.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -66,5 +66,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "lib/sphere_form.c"]
+source = ["lib/sas_3j1x_x.c", "lib/sphere_form.c"]
 
 # No volume normalization despite having a volume parameter
Index: sasmodels/models/spherical_sld.c
===================================================================
--- sasmodels/models/spherical_sld.c	(revision 54bcd4abeaba4faf03e24319c050286fc10969da)
+++ sasmodels/models/spherical_sld.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -34,5 +34,5 @@
     const double qr = q * r;
     const double qrsq = qr * qr;
-    const double bes = sph_j1c(qr);
+    const double bes = sas_3j1x_x(qr);
     double sinqr, cosqr;
     SINCOS(qr, sinqr, cosqr);
@@ -60,7 +60,7 @@
 
         // uniform shell; r=0 => r^3=0 => f=0, so works for core as well.
-        f -= M_4PI_3 * cube(r) * sld_l * sph_j1c(q*r);
+        f -= M_4PI_3 * cube(r) * sld_l * sas_3j1x_x(q*r);
         r += thickness[shell];
-        f += M_4PI_3 * cube(r) * sld_l * sph_j1c(q*r);
+        f += M_4PI_3 * cube(r) * sld_l * sas_3j1x_x(q*r);
 
         // iterate over sub_shells in the interface
@@ -92,5 +92,5 @@
     }
     // add in solvent effect
-    f -= M_4PI_3 * cube(r) * sld_solvent * sph_j1c(q*r);
+    f -= M_4PI_3 * cube(r) * sld_solvent * sas_3j1x_x(q*r);
 
     const double f2 = f * f * 1.0e-4;
Index: sasmodels/models/spherical_sld.py
===================================================================
--- sasmodels/models/spherical_sld.py	(revision 2d65d51719530a31ea7870f34610b834f36a1319)
+++ sasmodels/models/spherical_sld.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -214,5 +214,5 @@
              ]
 # pylint: enable=bad-whitespace, line-too-long
-source = ["lib/polevl.c", "lib/sas_erf.c", "lib/sph_j1c.c", "spherical_sld.c"]
+source = ["lib/polevl.c", "lib/sas_erf.c", "lib/sas_3j1x_x.c", "spherical_sld.c"]
 single = False  # TODO: fix low q behaviour
 
Index: sasmodels/models/stacked_disks.c
===================================================================
--- sasmodels/models/stacked_disks.c	(revision 0d6e86566d51a1fba22933bdbac8c40d36f9bd76)
+++ sasmodels/models/stacked_disks.c	(revision 6c3e2666e0741d50f118672e164dfa561dcc7765)
@@ -14,6 +14,18 @@
           double solvent_sld);
 
+double Iqxy(double qx, double qy,
+          double thick_core,
+          double thick_layer,
+          double radius,
+          double n_stacking,
+          double sigma_dnn,
+          double core_sld,
+          double layer_sld,
+          double solvent_sld,
+          double theta,
+          double phi);
+
 static
-double _kernel(double qq,
+double _kernel(double q,
                double radius,
                double core_sld,
@@ -22,5 +34,6 @@
                double halfheight,
                double thick_layer,
-               double zi,
+               double sin_alpha,
+               double cos_alpha,
                double sigma_dnn,
                double d,
@@ -28,45 +41,48 @@
 
 {
-	// qq is the q-value for the calculation (1/A)
-	// radius is the core radius of the cylinder (A)
-	// *_sld are the respective SLD's
-	// halfheight is the *Half* CORE-LENGTH of the cylinder = L (A)
-	// zi is the dummy variable for the integration (x in Feigin's notation)
-
-	const double besarg1 = qq*radius*sin(zi);
-	const double besarg2 = qq*radius*sin(zi);
-
-	const double sinarg1 = qq*halfheight*cos(zi);
-	const double sinarg2 = qq*(halfheight+thick_layer)*cos(zi);
-
-	const double be1 = sas_J1c(besarg1);
-	const double be2 = sas_J1c(besarg2);
-	const double si1 = sin(sinarg1)/sinarg1;
-	const double si2 = sin(sinarg2)/sinarg2;
-
-	const double dr1 = (core_sld-solvent_sld);
-	const double dr2 = (layer_sld-solvent_sld);
-	const double area = M_PI*radius*radius;
-	const double totald=2.0*(thick_layer+halfheight);
-
-	const double t1 = area*(2.0*halfheight)*dr1*(si1)*(be1);
-	const double t2 = area*dr2*(totald*si2-2.0*halfheight*si1)*(be2);
-
-
-	double retval =((t1+t2)*(t1+t2))*sin(zi);
-
-	// loop for the structure facture S(q)
-	double sqq=0.0;
-	for(int kk=1;kk<n_stacking;kk+=1) {
-		double dexpt=qq*cos(zi)*qq*cos(zi)*d*d*sigma_dnn*sigma_dnn*kk/2.0;
-		sqq=sqq+(n_stacking-kk)*cos(qq*cos(zi)*d*kk)*exp(-1.*dexpt);
-	}
-
-	// end of loop for S(q)
-	sqq=1.0+2.0*sqq/n_stacking;
-
-	retval *= sqq;
-
-	return(retval);
+    // q is the q-value for the calculation (1/A)
+    // radius is the core radius of the cylinder (A)
+    // *_sld are the respective SLD's
+    // halfheight is the *Half* CORE-LENGTH of the cylinder = L (A)
+    // zi is the dummy variable for the integration (x in Feigin's notation)
+
+    const double besarg1 = q*radius*sin_alpha;
+    //const double besarg2 = q*radius*sin_alpha;
+
+    const double sinarg1 = q*halfheight*cos_alpha;
+    const double sinarg2 = q*(halfheight+thick_layer)*cos_alpha;
+
+    const double be1 = sas_2J1x_x(besarg1);
+    //const double be2 = sas_2J1x_x(besarg2);
+    const double be2 = be1;
+    const double si1 = sas_sinx_x(sinarg1);
+    const double si2 = sas_sinx_x(sinarg2);
+
+    const double dr1 = core_sld - solvent_sld;
+    const double dr2 = layer_sld - solvent_sld;
+    const double area = M_PI*radius*radius;
+    const double totald = 2.0*(thick_layer + halfheight);
+
+    const double t1 = area * (2.0*halfheight) * dr1 * si1 * be1;
+    const double t2 = area * dr2 * (totald*si2 - 2.0*halfheight*si1) * be2;
+
+    double pq = square(t1 + t2);
+
+    // loop for the structure factor S(q)
+    double qd_cos_alpha = q*d*cos_alpha;
+    //d*cos_alpha is the projection of d onto q (in other words the component
+    //of d that is parallel to q.
+    double debye_arg = -0.5*square(qd_cos_alpha*sigma_dnn);
+    double sq=0.0;
+    for (int kk=1; kk<n_stacking; kk++) {
+        sq += (n_stacking-kk) * cos(qd_cos_alpha*kk) * exp(debye_arg*kk);
+    }
+    // end of loop for S(q)
+    sq = 1.0 + 2.0*sq/n_stacking;
+
+    return pq * sq * n_stacking;
+    // volume normalization should be per disk not per stack but form_volume
+    // is per stack so correct here for now.  Could change form_volume but
+    // if one ever wants to use P*S we need the ER based on the total volume
 }
 
@@ -83,94 +99,35 @@
                             double solvent_sld)
 {
-/*	StackedDiscsX  :  calculates the form factor of a stacked "tactoid" of core shell disks
+/*    StackedDiscsX  :  calculates the form factor of a stacked "tactoid" of core shell disks
 like clay platelets that are not exfoliated
 */
-	double summ = 0.0;	//initialize integral
-
-	double d=2.0*thick_layer+thick_core;
-	double halfheight = thick_core/2.0;
-
-	for(int i=0;i<N_POINTS_76;i++) {
-		double zi = (Gauss76Z[i] + 1.0)*M_PI/4.0;
-		double yyy = Gauss76Wt[i] *
-                    _kernel(q,
-		                   radius,
-		                   core_sld,
-		                   layer_sld,
-		                   solvent_sld,
-		                   halfheight,
-		                   thick_layer,
-		                   zi,
-		                   sigma_dnn,
-		                   d,
-		                   n_stacking);
-		summ += yyy;
-	}
-
-	double answer = M_PI/4.0*summ;
-
-	//Convert to [cm-1]
-	answer *= 1.0e-4;
-
-	return answer;
-}
-
-static double stacked_disks_kernel_2d(double q, double q_x, double q_y,
-                            double thick_core,
-                            double thick_layer,
-                            double radius,
-                            double n_stacking,
-                            double sigma_dnn,
-                            double core_sld,
-                            double layer_sld,
-                            double solvent_sld,
-                            double theta,
-                            double phi)
-{
-
-    double ct, st, cp, sp;
-
-    //convert angle degree to radian
-    theta = theta * M_PI/180.0;
-    phi = phi * M_PI/180.0;
-
-    SINCOS(theta, st, ct);
-    SINCOS(phi, sp, cp);
-
-    // silence compiler warnings about unused variable
-    (void) sp;
-
-    // parallelepiped orientation
-    const double cyl_x = st * cp;
-    const double cyl_y = st * sp;
-
-    // Compute the angle btw vector q and the
-    // axis of the parallelepiped
-    const double cos_val = cyl_x*q_x + cyl_y*q_y;
-
-    // Note: cos(alpha) = 0 and 1 will get an
-    // undefined value from Stackdisc_kern
-    double alpha = acos( cos_val );
-
-    // Call the IGOR library function to get the kernel
-    double d = 2 * thick_layer + thick_core;
-    double halfheight = thick_core/2.0;
-    double answer = _kernel(q,
-                     radius,
-                     core_sld,
-                     layer_sld,
-                     solvent_sld,
-                     halfheight,
-                     thick_layer,
-                     alpha,
-                     sigma_dnn,
-                     d,
-                     n_stacking);
-
-    answer /= sin(alpha);
-    //convert to [cm-1]
-    answer *= 1.0e-4;
-
-    return answer;
+    double summ = 0.0;    //initialize integral
+
+    double d = 2.0*thick_layer+thick_core;
+    double halfheight = 0.5*thick_core;
+
+    for(int i=0; i<N_POINTS_76; i++) {
+        double zi = (Gauss76Z[i] + 1.0)*M_PI_4;
+        double sin_alpha, cos_alpha; // slots to hold sincos function output
+        SINCOS(zi, sin_alpha, cos_alpha);
+        double yyy = _kernel(q,
+                           radius,
+                           core_sld,
+                           layer_sld,
+                           solvent_sld,
+                           halfheight,
+                           thick_layer,
+                           sin_alpha,
+                           cos_alpha,
+                           sigma_dnn,
+                           d,
+                           n_stacking);
+        summ += Gauss76Wt[i] * yyy * sin_alpha;
+    }
+
+    double answer = M_PI_4*summ;
+
+    //Convert to [cm-1]
+    return 1.0e-4*answer;
 }
 
@@ -179,6 +136,6 @@
                    double radius,
                    double n_stacking){
-    double d = 2 * thick_layer + thick_core;
-    return acos(-1.0) * radius * radius * d * n_stacking;
+    double d = 2.0 * thick_layer + thick_core;
+    return M_PI * radius * radius * d * n_stacking;
 }
 
@@ -203,2 +160,41 @@
                     solvent_sld);
 }
+
+
+double
+Iqxy(double qx, double qy,
+     double thick_core,
+     double thick_layer,
+     double radius,
+     double n_stacking,
+     double sigma_dnn,
+     double core_sld,
+     double layer_sld,
+     double solvent_sld,
+     double theta,
+     double phi)
+{
+    double q, sin_alpha, cos_alpha;
+    ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
+
+    double d = 2.0 * thick_layer + thick_core;
+    double halfheight = 0.5*thick_core;
+    double answer = _kernel(q,
+                     radius,
+                     core_sld,
+                     layer_sld,
+                     solvent_sld,
+                     halfheight,
+                     thick_layer,
+                     sin_alpha,
+                     cos_alpha,
+                     sigma_dnn,
+                     d,
+                     n_stacking);
+
+    //convert to [cm-1]
+    answer *= 1.0e-4;
+
+    return answer;
+}
+
Index: sasmodels/models/stacked_disks.py
===================================================================
--- sasmodels/models/stacked_disks.py	(revision ef5a3145c555427a3626384f3a1ca07763f4d48f)
+++ sasmodels/models/stacked_disks.py	(revision b7e8b94b477e6d9a7e4e2666bb218d3568ee66d2)
@@ -1,24 +1,20 @@
 r"""
-This model provides the form factor, $P(q)$, for stacked discs (tactoids)
-with a core/layer structure where the form factor is normalized by the volume
-of the cylinder. Assuming the next neighbor distance (d-spacing) in a stack
-of parallel discs obeys a Gaussian distribution, a structure factor $S(q)$
-proposed by Kratky and Porod in 1949 is used in this function.
-
-Note that the resolution smearing calculation uses 76 Gauss quadrature points
-to properly smear the model since the function is HIGHLY oscillatory,
-especially around the q-values that correspond to the repeat distance of
-the layers.
-
-The 2D scattering intensity is the same as 1D, regardless of the orientation
-of the q vector which is defined as
-
-.. math:: q = \sqrt{q_x^2 + q_y^2}
-
 Definition
 ----------
 
+This model provides the form factor, $P(q)$, for stacked discs (tactoids)
+with a core/layer structure which is constructed itself as $P(q) S(Q)$
+multiplying a $P(q)$ for individual core/layer disks by a structure factor
+$S(q)$ proposed by Kratky and Porod in 1949\ [#CIT1949]_ assuming the next
+neighbor distance (d-spacing) in the stack of parallel discs obeys a Gaussian
+distribution. As such the normalization of this "composite" form factor is
+relative to the individual disk volume, not the volume of the stack of disks.
+This model is appropriate for example for non non exfoliated clay particles such
+as Laponite.
+
 .. figure:: img/stacked_disks_geometry.png
 
+   Geometry of a single core/layer disk
+
 The scattered intensity $I(q)$ is calculated as
 
@@ -26,6 +22,7 @@
 
     I(q) = N\int_{0}^{\pi /2}\left[ \Delta \rho_t
-    \left( V_t f_t(q) - V_c f_c(q)\right) + \Delta \rho_c V_c f_c(q)
-    \right]^2 S(q)\sin{\alpha}\ d\alpha + \text{background}
+    \left( V_t f_t(q,\alpha) - V_c f_c(q,\alpha)\right) + \Delta
+    \rho_c V_c f_c(q,\alpha)\right]^2 S(q,\alpha)\sin{\alpha}\ d\alpha
+    + \text{background}
 
 where the contrast
@@ -35,22 +32,17 @@
     \Delta \rho_i = \rho_i - \rho_\text{solvent}
 
-and $N$ is the number of discs per unit volume,
-$\alpha$ is the angle between the axis of the disc and $q$,
-and $V_t$ and $V_c$ are the total volume and the core volume of
-a single disc, respectively.
-
-.. math::
-
-    \left\langle f_{t}^2(q)\right\rangle_{\alpha} =
-    \int_{0}^{\pi/2}\left[
+and $N$ is the number of individual (single) discs per unit volume, $\alpha$ is
+the angle between the axis of the disc and $q$, and $V_t$ and $V_c$ are the
+total volume and the core volume of a single disc, respectively, and
+
+.. math::
+
+    f_t(q,\alpha) =
     \left(\frac{\sin(q(d+h)\cos{\alpha})}{q(d+h)\cos{\alpha}}\right)
     \left(\frac{2J_1(qR\sin{\alpha})}{qR\sin{\alpha}} \right)
-    \right]^2 \sin{\alpha}\ d\alpha
-
-    \left\langle f_{c}^2(q)\right\rangle_{\alpha} =
-    \int_{0}^{\pi/2}\left[
+
+    f_c(q,\alpha) =
     \left(\frac{\sin(qh)\cos{\alpha})}{qh\cos{\alpha}}\right)
     \left(\frac{2J_1(qR\sin{\alpha})}{qR\sin{\alpha}}\right)
-    \right]^2 \sin{\alpha}\ d\alpha
 
 where $d$ = thickness of the layer (*thick_layer*),
@@ -59,13 +51,16 @@
 .. math::
 
-    S(q) = 1 + \frac{1}{2}\sum_{k=1}^n(n-k)\cos{(kDq\cos{\alpha})}
-    \exp\left[ -k(q\cos{\alpha})^2\sigma_d/2\right]
+    S(q,\alpha) = 1 + \frac{1}{2}\sum_{k=1}^n(n-k)\cos{(kDq\cos{\alpha})}
+    \exp\left[ -k(q)^2(D\cos{\alpha}~\sigma_d)^2/2\right]
 
 where $n$ is the total number of the disc stacked (*n_stacking*),
 $D = 2(d+h)$ is the next neighbor center-to-center distance (d-spacing),
 and $\sigma_d$ = the Gaussian standard deviation of the d-spacing (*sigma_d*).
+Note that $D\cos(\alpha)$ is the component of $D$ parallel to $q$ and the last
+term in the equation above is effectively a Debye-Waller factor term. 
 
 .. note::
-    Each assembly in the stack is layer/core/layer, so the spacing of the
+
+    1. Each assembly in the stack is layer/core/layer, so the spacing of the
     cores is core plus two layers. The 2nd virial coefficient of the cylinder
     is calculated based on the *radius* and *length*
@@ -74,4 +69,9 @@
     is applied.
 
+    2. the resolution smearing calculation uses 76 Gaussian quadrature points
+    to properly smear the model since the function is HIGHLY oscillatory,
+    especially around the q-values that correspond to the repeat distance of
+    the layers.
+
 To provide easy access to the orientation of the stacked disks, we define
 the axis of the cylinder using two angles $\theta$ and $\varphi$.
@@ -79,27 +79,26 @@
 .. figure:: img/cylinder_angle_definition.jpg
 
-    Examples of the angles against
-    the detector plane.
-
-
-Our model uses the form factor calculations implemented in a c-library provided
-by the NIST Center for Neutron Research (Kline, 2006)
+    Examples of the angles against the detector plane.
+
+
+Our model is derived from the form factor calculations implemented in a
+c-library provided by the NIST Center for Neutron Research\ [#CIT_Kline]_
 
 References
 ----------
 
-A Guinier and G Fournet, *Small-Angle Scattering of X-Rays*,
-John Wiley and Sons, New York, 1955
-
-O Kratky and G Porod, *J. Colloid Science*, 4, (1949) 35
-
-J S Higgins and H C Benoit, *Polymers and Neutron Scattering*,
-Clarendon, Oxford, 1994
-
-**Author:** NIST IGOR/DANSE **on:** pre 2010
-
-**Last Modified by:** Piotr Rozyczko **on:** February 18, 2016
-
-**Last Reviewed by:** Richard Heenan **on:** March 22, 2016
+.. [#CIT1949] O Kratky and G Porod, *J. Colloid Science*, 4, (1949) 35
+.. [#CIT_Kline] S R Kline, *J Appl. Cryst.*, 39 (2006) 895
+.. [#] J S Higgins and H C Benoit, *Polymers and Neutron Scattering*,
+   Clarendon, Oxford, 1994
+.. [#] A Guinier and G Fournet, *Small-Angle Scattering of X-Rays*,
+   John Wiley and Sons, New York, 1955
+
+Authorship and Verification
+----------------------------
+
+* **Author:** NIST IGOR/DANSE **Date:** pre 2010
+* **Last Modified by:** Paul Butler and Paul Kienzle **on:** November 26, 2016
+* **Last Reviewed by:** Paul Butler and Paul Kienzle **on:** November 26, 2016
 """
 
@@ -107,5 +106,5 @@
 
 name = "stacked_disks"
-title = ""
+title = "Form factor for a stacked set of non exfoliated core/shell disks"
 description = """\
     One layer of disk consists of a core, a top layer, and a bottom layer.
@@ -149,94 +148,99 @@
             sld_layer=0.0,
             sld_solvent=5.0,
-            theta=0,
+            theta=90,
             phi=0)
-#After redefinition to spherical coordinates find new reasonable test values
-#tests = [
-#    # Accuracy tests based on content in test/utest_extra_models.py.
-#    # Added 2 tests with n_stacked = 5 using SasView 3.1.2 - PDB
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 1.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#      'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, 0.001, 5075.12],
-
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 5.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#      'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, 0.001, 5065.12793824],
-
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 5.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#      'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, 0.164, 0.0127673597265],
-
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 1.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#      'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, [0.001, 90.0], [5075.12, 0.001]],
-
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 1.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#      'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, ([0.4, 0.5]), [0.00105074, 0.00121761]],
-
-#    [{'thick_core': 10.0,
-#      'thick_layer': 15.0,
-#      'radius': 3000.0,
-#      'n_stacking': 1.0,
-#      'sigma_d': 0.0,
-#      'sld_core': 4.0,
-#      'sld_layer': -0.4,
-#     'solvent_sd': 5.0,
-#      'theta': 0.0,
-#      'phi': 0.0,
-#      'scale': 0.01,
-#      'background': 0.001,
-#     }, ([1.3, 1.57]), [0.0010039, 0.0010038]],
-#    ]
-# 21Mar2016   RKH notes that unit tests all have n_stacking=1, ought to test other values
-
+# After redefinition of spherical coordinates -
+# tests had in old coords theta=0, phi=0; new coords theta=90, phi=0
+# but should not matter here as so far all the tests are 1D not 2D
+tests = [
+# Accuracy tests based on content in test/utest_extra_models.py.
+# Added 2 tests with n_stacked = 5 using SasView 3.1.2 - PDB; for which alas q=0.001 values seem closer to n_stacked=1 not 5, changed assuming my 4.1 code OK, RKH
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 1.0,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+     }, 0.001, 5075.12],
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 5,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+#     }, 0.001, 5065.12793824],    n_stacking=1 not 5 ? slight change in value here 11jan2017, check other cpu types
+#     }, 0.001, 5075.11570493],
+     }, 0.001, 25325.635693],
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 5,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+#     }, 0.164, 0.0127673597265],    n_stacking=1 not 5 ?  slight change in value here 11jan2017, check other cpu types
+#     }, 0.164, 0.01480812968],
+     }, 0.164, 0.0598367986509],
+
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 1.0,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+# second test here was at q=90, changed it to q=5, note I(q) is then just value of flat background
+     }, [0.001, 5.0], [5075.12, 0.001]],
+
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 1.0,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+     }, ([0.4, 0.5]), [0.00105074, 0.00121761]],
+
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 1.0,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+     'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 0.0,
+      'scale': 0.01,
+      'background': 0.001,
+     }, ([1.3, 1.57]), [0.0010039, 0.0010038]],
+    ]
+# 11Jan2017   RKH checking unit test agai, note they are all 1D, no 2D
+
Index: sasmodels/models/star_polymer.c
===================================================================
--- sasmodels/models/star_polymer.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/star_polymer.c	(revision 3a48772f136eb2795903c63707474e7527b4a325)
@@ -6,11 +6,11 @@
 {
 
-    double u_2 = radius2 * pow(q,2);
+    double u_2 = radius2 * q * q;
     double v = u_2 * arms / (3.0 * arms - 2.0);
 
-    double term1 = v - 1.0 + exp(-v);
-    double term2 = ((arms - 1.0)/2.0)* pow((1.0 - exp(-v)),2.0);
+    double term1 = v + expm1(-v);
+    double term2 = ((arms - 1.0)/2.0) * square(expm1(-v));
 
-    return (2.0 * (term1 + term2)) / (arms * pow(v,2.0));
+    return (2.0 * (term1 + term2)) / (arms * v * v);
 
 }
